diff --git a/drivers/bus/fslmc/qbman/qbman_sys_decl.h b/drivers/bus/fslmc/qbman/qbman_sys_decl.h
index caaae417773c..2b6162d0ceaf 100644
--- a/drivers/bus/fslmc/qbman/qbman_sys_decl.h
+++ b/drivers/bus/fslmc/qbman/qbman_sys_decl.h
@@ -9,7 +9,7 @@
 #include <compat.h>
 #include <fsl_qbman_base.h>
 
-/* Sanity check */
+/* Byte order check */
 #if (__BYTE_ORDER__ != __ORDER_BIG_ENDIAN__) && \
 	(__BYTE_ORDER__ != __ORDER_LITTLE_ENDIAN__)
 #error "Unknown endianness!"
diff --git a/drivers/common/cnxk/roc_npa.c b/drivers/common/cnxk/roc_npa.c
index 5e38ecf0414e..bd8ab1b39584 100644
--- a/drivers/common/cnxk/roc_npa.c
+++ b/drivers/common/cnxk/roc_npa.c
@@ -622,7 +622,7 @@ npa_aura_alloc(struct npa_lf *lf, const uint32_t block_count, int pool_id,
 {
 	int rc, aura_id;
 
-	/* Sanity check */
+	/* parameter check */
 	if (!lf || !aura || !aura_handle)
 		return NPA_ERR_PARAM;
 
diff --git a/drivers/common/dpaax/caamflib/desc.h b/drivers/common/dpaax/caamflib/desc.h
index 4a1285c4d488..37c87eebd5b4 100644
--- a/drivers/common/dpaax/caamflib/desc.h
+++ b/drivers/common/dpaax/caamflib/desc.h
@@ -107,7 +107,7 @@ extern enum rta_sec_era rta_sec_era;
 
 /*
  * ONE - should always be set. Combination of ONE (always
- * set) and ZRO (always clear) forms an endianness sanity check
+ * set) and ZRO (always clear) forms an endianness check
  */
 #define HDR_ONE			BIT(23)
 #define HDR_ZRO			BIT(15)
diff --git a/drivers/common/sfc_efx/base/ef10_nvram.c b/drivers/common/sfc_efx/base/ef10_nvram.c
index ce8357fa94ce..fad9f0f507f3 100644
--- a/drivers/common/sfc_efx/base/ef10_nvram.c
+++ b/drivers/common/sfc_efx/base/ef10_nvram.c
@@ -595,13 +595,13 @@ tlv_update_partition_len_and_cks(
 
 	/*
 	 * We just modified the partition, so the total length may not be
-	 * valid. Don't use tlv_find(), which performs some sanity checks
+	 * valid. Don't use tlv_find(), which performs some checks
 	 * that may fail here.
 	 */
 	partition.data = cursor->block;
 	memcpy(&partition.tlv_cursor, cursor, sizeof (*cursor));
 	header = (struct tlv_partition_header *)partition.data;
-	/* Sanity check. */
+	/* Header check */
 	if (__LE_TO_CPU_32(header->tag) != TLV_TAG_PARTITION_HEADER) {
 		rc = EFAULT;
 		goto fail1;
diff --git a/drivers/common/sfc_efx/base/efx_rx.c b/drivers/common/sfc_efx/base/efx_rx.c
index dce9ada55d28..28676c5a5b99 100644
--- a/drivers/common/sfc_efx/base/efx_rx.c
+++ b/drivers/common/sfc_efx/base/efx_rx.c
@@ -930,7 +930,7 @@ efx_rx_qcreate_internal(
 	    ndescs, id, flags, eep, erp)) != 0)
 		goto fail4;
 
-	/* Sanity check queue creation result */
+	/* Check queue creation result */
 	if (flags & EFX_RXQ_FLAG_RSS_HASH) {
 		const efx_rx_prefix_layout_t *erplp = &erp->er_prefix_layout;
 		const efx_rx_prefix_field_info_t *rss_hash_field;
diff --git a/drivers/dma/idxd/idxd_pci.c b/drivers/dma/idxd/idxd_pci.c
index a78889a7efa0..ba36a96f085d 100644
--- a/drivers/dma/idxd/idxd_pci.c
+++ b/drivers/dma/idxd/idxd_pci.c
@@ -204,7 +204,7 @@ init_pci_device(struct rte_pci_device *dev, struct idxd_dmadev *idxd,
 		goto err;
 	}
 
-	/* sanity check device status */
+	/* check device status */
 	if (pci->regs->gensts & GENSTS_DEV_STATE_MASK) {
 		/* need function-level-reset (FLR) or is enabled */
 		IDXD_PMD_ERR("Device status is not disabled, cannot init");
diff --git a/drivers/net/bonding/rte_eth_bond_8023ad.c b/drivers/net/bonding/rte_eth_bond_8023ad.c
index 79f1b3f1a0f2..57a67bd029ed 100644
--- a/drivers/net/bonding/rte_eth_bond_8023ad.c
+++ b/drivers/net/bonding/rte_eth_bond_8023ad.c
@@ -1476,7 +1476,7 @@ bond_8023ad_setup_validate(uint16_t port_id,
 		return -EINVAL;
 
 	if (conf != NULL) {
-		/* Basic sanity check */
+		/* Basic input check */
 		if (conf->slow_periodic_ms == 0 ||
 				conf->fast_periodic_ms >= conf->slow_periodic_ms ||
 				conf->long_timeout_ms == 0 ||
diff --git a/drivers/net/mvpp2/mrvl_qos.c b/drivers/net/mvpp2/mrvl_qos.c
index f43217bc589c..db5052a9ab6f 100644
--- a/drivers/net/mvpp2/mrvl_qos.c
+++ b/drivers/net/mvpp2/mrvl_qos.c
@@ -260,7 +260,7 @@ get_entry_values(const char *entry, uint8_t *tab,
 			if (nb_rng_tokens != 2)
 				return -3;
 
-			/* Range and sanity checks. */
+			/* Range and input checks. */
 			if (get_val_securely(rng_tokens[0], &token_val) < 0)
 				return -4;
 			beg = (char)token_val;
diff --git a/drivers/net/nfp/nfp_flow.c b/drivers/net/nfp/nfp_flow.c
index f832b52d8996..c867697e05c9 100644
--- a/drivers/net/nfp/nfp_flow.c
+++ b/drivers/net/nfp/nfp_flow.c
@@ -2071,7 +2071,7 @@ nfp_flow_compile_item_proc(struct nfp_flower_representor *repr,
 			break;
 		}
 
-		/* Perform basic sanity checks */
+		/* Perform basic checks */
 		ret = nfp_flow_item_check(item, proc);
 		if (ret != 0) {
 			PMD_DRV_LOG(ERR, "nfp flow item %d check failed", item->type);
diff --git a/drivers/net/qede/qede_rxtx.c b/drivers/net/qede/qede_rxtx.c
index c35585f5fdd6..8b89841e03b1 100644
--- a/drivers/net/qede/qede_rxtx.c
+++ b/drivers/net/qede/qede_rxtx.c
@@ -1383,7 +1383,7 @@ qede_rx_process_tpa_end_cqe(struct qede_dev *qdev,
 					     cqe->len_list[0]);
 	/* Update total length and frags based on end TPA */
 	rx_mb = rxq->tpa_info[cqe->tpa_agg_index].tpa_head;
-	/* TODO:  Add Sanity Checks */
+	/* TODO:  Add more checks */
 	rx_mb->nb_segs = cqe->num_of_bds;
 	rx_mb->pkt_len = cqe->total_packet_len;
 
@@ -2211,7 +2211,7 @@ qede_xmit_prep_pkts(__rte_unused void *p_txq, struct rte_mbuf **tx_pkts,
 
 #ifdef RTE_LIBRTE_QEDE_DEBUG_TX
 static inline void
-qede_mpls_tunn_tx_sanity_check(struct rte_mbuf *mbuf,
+qede_mpls_tunn_tx_basic_check(struct rte_mbuf *mbuf,
 			       struct qede_tx_queue *txq)
 {
 	if (((mbuf->outer_l2_len + mbuf->outer_l3_len) / 2) > 0xff)
@@ -2473,7 +2473,7 @@ qede_xmit_pkts(void *p_txq, struct rte_mbuf **tx_pkts, uint16_t nb_pkts)
 						RTE_MBUF_F_TX_TUNNEL_MPLSINUDP) {
 				mplsoudp_flg = true;
 #ifdef RTE_LIBRTE_QEDE_DEBUG_TX
-				qede_mpls_tunn_tx_sanity_check(mbuf, txq);
+				qede_mpls_tunn_tx_basic_check(mbuf, txq);
 #endif
 				/* Outer L4 offset in two byte words */
 				tunn_l4_hdr_start_offset =